# Copyright 2023-2024 by Advanced Technology Systems, LLC.
#
# Unless required by applicable law or agreed to in writing, this software is provided on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND.
#
# Licensed by Advanced Technology Systems, LLC.  The full license is available at:
# http://advtechnologysystems.com/license

class StandardAWSConfigReplacer(object):

    def __init__(self, list_of_replacements):
        self.__list_of_tags = ["<account>", "<region>"]
        self._list_of_replacements = list_of_replacements
        self._validate()

    def do_replacements(self, config_file_name):

        with open(config_file_name) as config_file:
            config_string = config_file.read()

        for i, the_tag in enumerate(self.__list_of_tags):
            config_string = config_string.replace(the_tag, self._list_of_replacements[i])

        return config_string

    def replace_strings(self, config_string):

        for i, the_tag in enumerate(self.__list_of_tags):
            config_string = config_string.replace(the_tag, self._list_of_replacements[i])

        return config_string

    def _validate(self):

        if len(self.__list_of_tags) != len(self._list_of_replacements):
            raise Exception("Replacement list length must match the list of tags length! "
                            "(The list of tags contains {} items.)".format(len(self.__list_of_tags)))
